; ==============================================
;                                CS Chess v1.56
;          (C) Copyright 12/05/2001  Cobra's Script, Inc.
;                           http://webmirc.cjb.net
; ==============================================

; =================
;      Mouse Events
; =================

menu @CS_Chess {
  sclick {
    tokenize 32 $chess.mouse(-p)
    var %chess.lastdraw = $gettok($cs.chess(parms),3-4,32)
    if ($1 isnum 1-5) {
      var %chess.tmp = $gettok(r;n;b;q;0,$1,59)
      if (%chess.tmp isin $cs.chess(gone)) {
        ; === Set Vars ===
        var %chess.tmp = $iif($cs.chess(self) == b, $upper(%chess.tmp), %chess.tmp)
        var %chess.p = $left(%chess.tmp,1)
        if (%chess.p isincs $cs.chess(map)) { chess.set gone $remtok($cs.chess(gone),$left(%chess.p,1),59) }
        ; === Set Map ===
        chess.draw %chess.lastdraw $cs.chess(%chess.tmp).key 1 1
        edit.map inplay %chess.tmp %chess.lastdraw | chess.set map $cs.chess(map.inplay)
        chess.text -s 12*** Pawn Replaced with $cs.chess(%chess.tmp).pick
        chess.send raw 013 -r $cs.chess(self) %chess.p
        chess.dead -r $cs.chess(self) %chess.p | tokenize 32 $cs.chess(parms)
        chess.send move $iif($cs.chess(self) == b, $cs.chess($1-4).convert, $1-4) $5- %chess.tmp
        chess.set -r move last.draw last.move
        close -@ @CS_Chess
        ; === Check for Check ===
        if ($chess.check($cs.chess(turn),$cs.chess($iif($cs.chess(turn) == b, K, k)).loc)) {
          if (!$cs.chess(check.flag)) {
            chess.set check.flag $true
            if ($cs.chess(server)) { chess.text -s $+(<,$cs.chess(nick),>) 4Check! }
            else { chess.send TEXT $+(<,$cs.chess(nick),>) 4Check! }
        } }
    } }
  }
}
menu @Chess* {
  mouse {
    ; echo -s * $mouse.x $mouse.y
    tokenize 32 $mouse.x $mouse.y
    if ($mouse.key & 1) {
      ; === Moveing Game Peice ===
      if ($cs.chess(turn) == $cs.chess(self)) && ($cs.chess(game)) {
        var %chess.mouse = $chess.mouse
        if (%chess.mouse) {
          if ($cs.chess(move)) && ($cs.chess(last.move) != %chess.mouse) {
            if ($chess.vmove(%chess.mouse)) { chess.disp %chess.mouse }
            chess.set last.move %chess.mouse
        } }
      }
      ; === Text Hilight ===
      if ($2 > 380) && ($cs.chess(hilight)) { chess.text.hilight -h $1 $2 }
    }
    elseif ($cs.chess(move)) { chess.set move $false }
  }
  sclick {
    tokenize 32 $mouse.x $mouse.y
    ; === Click on Game Peice ===
    if ($1 < 380) && ($2 < 380) {
      if ($cs.chess(turn) == $cs.chess(self)) && ($cs.chess(game)) {
        if ($cs.chess($chess.mouse).wb == $cs.chess(self)) {
          var %chess.mouse $chess.mouse
          chess.set last.draw %chess.mouse | chess.set mouse.click %chess.mouse
          chess.set map.inplay $cs.chess(map) | chess.set last.move %chess.mouse
          chess.set move $true | chess.set draw.flag $false
      } }
    }
    ; === Click on History Table UP ===
    if ($1 isnum 509-517) && ($2 isnum 61-68) { chess.move.tbl -up }
    ; === Click on History Table Down ===
    if ($1 isnum 509-517) && ($2 isnum 134-141) { chess.move.tbl -down }
    ; === Click Text ScrolBar ===
    tokenize 32 $cs.chess(-n,$1-2).sb
    if ($1 isnum 525-540) {
      if ($2 isnum 380-390) { chess.sb -up | .timersb1 -m 1 500 .timersb2 -m 0 50 chess.sb -up }
      if ($2 isnum 422-432) { chess.sb -down | .timersb1 -m 1 500 .timersb2 -m 0 50 chess.sb -down }
    }
    ; === Text Hilight ===
    if ($2 > 380) { chess.text.hilight -s $1 $2 }
  }
  uclick {
    if ($cs.chess(hilight)) {
      var %cs.text = $cs.chess(hl.fstring)
      var %cs.text = $strip($gettok($replace(%cs.text,$chr(160),$chr(32)),$iif($left(%cs.text,1) == ,1,2),$asc()))
      clipboard -a $+(%cs.text,$iif($cb(0) > 1, $crlf))
      chess.set -r hilight hl.* | unset %chess.hl.ctr | chess.sb -refresh
    } | if ($timer(sb1)) { .timersb1 off } | if ($timer(sb2)) { .timersb2 off }
  }
  leave {
    if ($cs.chess(hilight)) {
      var %cs.text = $cs.chess(hl.fstring)
      clipboard -a $+($gettok($replace(%cs.text,$chr(160),$chr(32)),$iif($left(%cs.text,1) == ,1,2),$asc()),$crlf)
      chess.set -r hilight hl.* | unset %chess.hl.ctr | chess.sb -refresh
    }
    if ($timer(sb1)) { .timersb1 off } | if ($timer(sb2)) { .timersb2 off }
  }
  dclick {
    tokenize 32 $mouse.x $mouse.y
    ; === Click on History Table UP ===
    if ($1 isnum 509-517) && ($2 isnum 61-68) { chess.move.tbl -up }
    ; === Click on History Table Down ===
    if ($1 isnum 509-517) && ($2 isnum 134-141) { chess.move.tbl -down }
    ; === Click Text ScrolBar ===
    tokenize 32 $cs.chess(-n,$1-2).sb
    if ($1 isnum 525-540) {
      if ($2 isnum 380-390) { chess.sb -up | .timersb1 -m 1 500 .timersb2 -m 0 50 chess.sb -up }
      if ($2 isnum 422-432) { chess.sb -down | .timersb1 -m 1 500 .timersb2 -m 0 50 chess.sb -down }
    }
  }
  drop {
    if ($cs.chess(move)) {
      ; === Set Game Peice ===
      var %chess.click = $cs.chess(mouse.click)
      var %chess.lastdraw = $cs.chess(last.draw)
      if (%chess.lastdraw != %chess.click) {
        chess.move %chess.click %chess.lastdraw $cs.chess(self)
      }
      chess.set -r move last.draw last.move
    }
  }
  ; === Popups ===
  $iif($chess.popup(1), &Join Game) { chess.client }
  $iif($chess.popup(1), &Host Game) { chess.server }
  -
  $iif($chess.popup && !$mouse.lb, Settings)
  .$+(Port,$chr(58))	 $cs.chess(port) {
    chess.set prompt Enter Port: | chess.set -r input
    var %cs.port = $$dialog(CS_Input,CS_Input,-3)
    writeini $chess.ini server port %cs.port | chess.set port %cs.port
    chess.text 12*** Port has been changed to Port %cs.port
  }
  -
  $iif($chess.popup(2),$($style(2) &Save)) { chess.game -s }
  $iif($chess.popup(2),$($style(2) &Load)) { chess.game -l }
  -
  $iif($chess.popup(3), &Quit) {
    chess.title Dssconnected | chess.raw 003
    chess.text 12*** Disconnected
    chess.set -r game turn self move.hist.* server
    chess.send quit | sockclose cs.chess
    chess.lights
  }
  $iif($chess.popup(4), &Disconnect) {
    chess.title Not Connected | chess.raw 003
    chess.set -r game turn self move.hist.* server
    chess.send CLOSE | sockclose *chess*
    chess.text 12*** Disconnected
    chess.lights
  }
  -
  $iif($chess.popup && !$mouse.lb, E&xit) { chess.close }
  ; === NickList Popups ===
  $chess.popup(set) { return }
  $iif($chess.popup(6), Challenge) {
    if ($cs.chess(server)) { chess.text 12*** $cs.chess(nick) Challenges %chess.snick }
    chess.send CHALLENGE $cs.chess(nick) %chess.snick
  }
  -
  $iif($chess.popup(5), Kick) {
    var %user.num = $cs.chess(-num,%chess.snick).user
    chess.set prompt Enter Kick Reason | chess.set -r input
    chess.text -s 3*** %chess.snick was kicked by $cs.chess(nick) ( $+ $$dialog(CS_Input,CS_Input,-3) $+ )
    chess.set user.num $remtok($cs.chess(user.num),%user.num,1,59)
    chess.set user.nick $remtok($cs.chess(user.nick),%chess.snick,1,59)
    chess.set names $remtok($cs.chess(names),%chess.snick,32)
    chess.raw 003 $cs.chess(names) | chess.send RAW 003 $cs.chess(names)
    if ($cs.chess(white) == %chess.snick) || ($cs.chess(black) == %chess.snick) {
      chess.send raw 006 | chess.raw 006
    } | sockclose $+(cs.chess.,%user.num)
  }
}
alias -l chess.popup {
  if ($mouse.key & 1) { return }
  if ($1 == set) { set -u60 %chess.snick $remove($sline($chess.window,1),@) | return }
  if ($1 == 1) { return $iif(!$mouse.lb && !$sock(*chess*,1), $true) }
  if ($1 == 2) { return $iif(!$mouse.lb && $sock(*chess*,1), $true) }
  if ($1 == 3) { return $iif(!$mouse.lb && $sock(*chess*,1) && !$cs.chess(server), $true) }
  if ($1 == 4) { return $iif(!$mouse.lb && $sock(*chess*,1) && $cs.chess(server), $true) }
  if ($1 == 5) { return $iif($mouse.lb && $sock(*chess*,1) && $cs.chess(server), $true) }
  if ($1 == 6) { return $iif($mouse.lb && !$cs.chess(game), $true) }
  return $true
}

; =================
;           Dialogs
; =================
; Note Dialogs created with the help of Dialog Studio

dialog CS_Input {
  title "CS Chess v1.56"
  size -1 -1 122 55
  option dbu
  edit $cs.chess(input) , 1, 6 18 111 10, autohs, result
  button "Ok", 2, 20 32 37 12,ok
  button "Cancel", 3, 70 32 37 12,cancel
  text $cs.chess(prompt) , 4, 7 7 60 8
}
dialog CS_Prompt {
  title "You've Been Challenged!"
  size -1 -1 99 40
  option dbu
  text $cs.chess(prompt) , 1, 4 7 90 8
  button "Yes", 2, 4 21 37 12, ok, result
  button "No", 3, 56 21 37 12, cancel
}
dialog CS_Prompt_ok {
  title "You've Been Challenged!"
  size -1 -1 99 40
  option dbu
  text $cs.chess(prompt) , 1, 4 7 90 8
  button "Ok", 2, 21 21 37 12, ok, result
}


; =================
;           Aliases
; =================
alias chess {
  if ($1 == /?) {
    echo -a 12* 
    echo -a 12* =================================
    echo -a 12* CS Chess $+(v,$chess.version)
    echo -a 12*  by Cobra^ (#mIRC / WebNet)
    echo -a 12*  cobra@webmirc.cjb.net
    echo -a 12* =================================
    echo -a 12*
    echo -a 12* /Chess $str($chr(160),24) - Start CS Chess !
    echo -a 12* /Chess -j <Host or IP> [Port] $str($chr(160),1) - Join Game
    echo -a 12* /Chess -s $str($chr(160),21) - Host Game
    echo -a 12*
    halt
  }
  if ($version < 5.91) {
    var %cs.tmp = $input($+(Can't Run CS Chess,$crlf,Invalid mIRC Version,$crlf,Get mIRC v5.91 or higher),4,Invalid mIRC Version)
    halt
  }

  ; === Get Transparent RGB Value ===
  window -hp @chess.tmp
  drawpic -cns @chess.tmp 0 0 $chess.bmp
  chess.set rgb $getdot(@chess.tmp,1,1)
  chess.set rgb0 $getdot(@chess.tmp,300,20)
  close -@ @chess.tmp

  if ($window($chess.window)) { window -a $chess.window | return }
  window -adhCepk0l10 +tn $chess.window 1 1 643 485 system 11 | chess.title

  unset %chess.* %mouse.* %cs.* | .remove $+(",$scriptdirchess.log,")
  drawfill -r $chess.window 0 0 0 0 | chess.board -c

  var %cs.port = $readini $chess.ini server port
  chess.set port $iif(%cs.port, %cs.port, 30)
  chess.set nick $me

  if ($1 == -j) { if ($3 isnum) { writeini $chess.ini server port $3 } | chess.client $2- }
  if (-s* iswm $1) { chess.server $remove($1,s) }
}

alias -l chess.board {
  ; === Clear Chess Board ===
  if ($1 == -c) {
    var %cs.wh = $cs.chess(1 1).wh
    drawtext -npb $chess.window 11 1 times 15 35 1 ABCDEFGH
    var %cs.ctr.y = 0
    while (%cs.ctr.y < 8) {
      inc %cs.ctr.y | var %cs.ctr.x = 0 
      drawtext -npb $chess.window 11 1 times 16 5 $calc((%cs.ctr.y - 1) * 45 + 32) $+(,%cs.ctr.y)
      while (%cs.ctr.x < 8) {
        inc %cs.ctr.x | var %cs.map.xy = %cs.ctr.x %cs.ctr.y
        var %cs.key.xy = $cs.chess($cs.chess(%cs.map.xy).sq).key
        drawpic -csn $chess.window $cs.chess(%cs.map.xy).xy %cs.wh $cs.chess(-p,%cs.key.xy).xy %cs.wh $chess.bmp
      }
    }
    ; === Clear Side nicks ===
    drawrect -fn $chess.window 1 1 383 163 135 18
    drawrect -fn $chess.window 1 1 383 212 135 18
    drawrect -fn $chess.window 1 1 422 360 120 14
    chess.lights | chess.draw -d
  }

  ; === Clear Dead List & Move History ===
  chess.dead -c | chess.move.tbl -c | chess.sb

  ; === Draw Chess Board ===
  if ($1 == -s) {
    var %cs.wh = $cs.chess(1 1).wh
    var %cs.rgb = $cs.chess(rgb)
    var %cs.ctr.y = 0
    while (%cs.ctr.y < 8) {
      inc %cs.ctr.y | var %cs.ctr.x = 0
      while (%cs.ctr.x < 8) {
        inc %cs.ctr.x | var %cs.map.xy = %cs.ctr.x %cs.ctr.y
        var %cs.map.p = $cs.chess(%cs.map.xy).p
        if (%cs.map.p) {
          var %cs.key.xy = $cs.chess(%cs.map.p).key
          drawpic -cst $chess.window %cs.rgb $cs.chess(%cs.map.xy).xy %cs.wh $cs.chess(-p,%cs.key.xy).xy %cs.wh $chess.bmp
      } }
    }
  } | chess.draw -d
}
alias -l chess.move.tbl {
  if ($1 == -c) {
    ; === Black out all Tables ===
    drawrect -fn $chess.window 1 1 425 17 95 140
    ; === Draw Table Structure ===
    drawrect -n $chess.window 10 2 426 18 90 135
    drawline -n $chess.window 11 1 431 37 511 37
    drawline -n $chess.window 10 1 431 54 511 54
    drawline -n $chess.window 10 1 471 41 471 148 
    ; === Draw Arrows ===
    drawrect -fn $chess.window 1 1 510 59 10 18
    drawrect -fn $chess.window 1 1 510 128 10 18
    drawline -n $chess.window 4 1 511 67 514 63 518 68
    drawline -n $chess.window 4 1 511 136 514 140 518 135
    ; === Draw Table Headings ===
    drawtext -npb $chess.window 4 1 times 15 431 20 Move History
    drawtext -npb $chess.window 11 1 times 12 433 38 Black
    drawtext -npb $chess.window 11 1 times 12 477 38 White
    chess.set -r move.hist.w move.hist.b
  }

  else {

    if ($1 == -up) {
      ; === Move History Table Up ===
      var %cs.tmp = $calc($cs.chess(move.tbl) - 1)
      var %cs.tmp = $iif(%cs.tmp < 1, 1, %cs.tmp)
      tokenize 32 %cs.tmp
    }
    if ($1 == -down) {
      ; === Move History Table Down ===
      var %cs.tmp = $calc($cs.chess(move.tbl) + 1)
      tokenize 32 %cs.tmp
    }

    tokenize 32 $iif($1, $1, 1)
    ; === Clear Table Data ===
    drawrect -fn $chess.window 1 1 433 57 38 90
    drawrect -fn $chess.window 1 1 473 57 38 90
    ; === Draw Table Data ===
    var %cs.b = $cs.chess(move.hist.b) | var %cs.w = $cs.chess(move.hist.w)
    var %cs.len = $numtok($iif($len(%cs.b) > $len(%cs.w), %cs.b, %cs.w),59)
    var %cs.tot = $calc((%cs.len - $1) + 2)
    tokenize 32 $iif($1 <= %cs.len, $1, %cs.len)
    if (%cs.b != $null) || (%cs.w != $null) {
      var %cs.ctr = $calc($1 - 1) 
      ; var %cs.tot = $calc(%cs.ctr + 8)
      var %cs.tot = $calc(%cs.ctr + $iif(%cs.tot < 8, %cs.tot, 8))
      while (%cs.ctr < %cs.tot) {
        inc %cs.ctr | var %cs.ctr2 = 0
        while (%cs.ctr2 < 2) {
          inc %cs.ctr2 | var %chess.tmp = $gettok($eval($+(%,cs.,$iif(%cs.ctr2 == 1, b, w)),2),$+(-,%cs.ctr),59)
          if (%cs.ctr <= $numtok($eval($+(%,cs.,$iif(%cs.ctr2 == 1, b, w)),2),59)) {
            if (%chess.tmp != $null) {
              drawtext -npb $chess.window $iif(%cs.ctr == 1, 0, 15) 1 times 10 $iif(%cs.ctr2 == 1, 433, 477) $calc(46 + ((%cs.ctr - ($1 - 1)) * 11)) $gettok(%chess.tmp,1,46)
              drawtext -npb $chess.window $iif(%cs.ctr == 1, 0, 15) 1 times 10 $iif(%cs.ctr2 == 1, 448, 492) $calc(46 + ((%cs.ctr - ($1 - 1)) * 11)) > $gettok(%chess.tmp,2,46)
        } } }
    } }
    chess.set move.tbl $1
  }
  drawdot $chess.window
}
alias -l chess.dead {
  ; chess.dead.tbl -a/r/c w/b peice
  if ($1 == -c) {
    chess.set dead.w $+($str(0;,15),0)
    chess.set dead.b $+($str(0;,15),0)
    drawrect -f $chess.window 5 1 384 17 35 144
    drawrect -f $chess.window 5 1 384 234 35 144
  }
  if ($istok(-a;-r,$1,59)) {
    var %cs.r = $iif($1 == -r, $true, $false)
    var %cs.dead = $cs.chess($+(dead.,$2))
    var %cs.y = $iif($cs.chess(self) == b, $iif($2 == b, 18, 234), $iif($2 == b, 234, 18))
    var %cs.key = $cs.chess($iif($2 == b, $upper($3), $3)).key
    ; === Pawn Placement ===
    if ($3 == p) {
      var %cs.calc = $calc($count(%cs.dead,p) / 2)
      var %cs.flg = $iif($numtok(%cs.calc,46) == $iif(%cs.r, 1, 2), $false, $true)
      var %cs.xy = $iif(%cs.flg, 384, 401) $calc(%cs.y + (18 * ( $iif(%cs.r, $($round(%cs.calc,0) -1), $int(%cs.calc)) +4 )))
      var %cs.put = $calc(%cs.calc * 2 + $iif(%cs.r, 8, 9))
    }
    ; === Other peices ===
    else {
      var %cs.flg = $iif($count(%cs.dead,$3) == $iif(%cs.r, 2, 1), $true, $false)
      var %cs.xy = $iif(%cs.flg, 401, 384) $calc(%cs.y + (18 * ($gettok(%cs.key,1,32) - 1)))
      var %cs.put = $calc(($gettok(%cs.key,1,32) * 2) - $iif(%cs.flg, 0, 1))
    }
    ; === Aply Changes ===
    chess.set $+(dead.,$2) $puttok(%cs.dead,$iif(%cs.r, 0, $3),%cs.put,59)
    if (%cs.r) { drawrect -f $chess.window 5 1 %cs.xy 18 18 }
    else { drawpic -cst $chess.window $cs.chess(rgb) %cs.xy 18 18 $cs.chess(-p,%cs.key).xy $cs.chess(1 1).wh $chess.bmp }
  }
}
alias -l chess.lights {
  ; === Clear Lights ===
  drawrect -nf $chess.window 1 1 480 4 40 10
  ; === Draw Box ===
  drawrect -n $chess.window 14 1 482 4 34 10
  ; === Draw Dots ===
  drawdot -n $chess.window $iif($cs.chess(game), 9, 4) 2 506 10
  if ($1 == -b) { chess.draw -d | var %ctr = 0 | while (%ctr < 200) { inc %ctr } }
  drawdot $chess.window $iif($sock(*chess*), 9, 4) 2 494 10
}
alias -l chess.sb {
  if (-* iswm $1) {
    if (!$cs.chess(sb.ctr)) { chess.set sb.ctr 0 }
    var %cs.file = $+(",$scriptdirchess.log,")
    var %sb.ctr = $cs.chess(sb.ctr)
    var %sb.tot = $lines(%cs.file)
    if ($1 == -up) { if (%sb.ctr == $calc(%sb.tot - 1)) { var %cs.sb.end = $true } | inc %sb.ctr }
    if ($1 == -down) { if (%sb.ctr == 0) { chess.set -r sb.flag | var %cs.sb.end = $true } | dec %sb.ctr }
    if (%cs.sb.end) { if ($timer(sb1)) { .timersb1 off } | if ($timer(sb2)) { .timersb2 off } | return }
    if ($1 != -refresh) { chess.set sb.flag = $true } | var %cs.ctr = 0
    drawrect -rnf $chess.window $rgb(0,0,0) 1 1 379 $cs.chess(523).sb 70
    while (%cs.ctr < 4) {
      inc %cs.ctr | var %cs.text = $read $+(-nl,$calc(%sb.tot - (%sb.ctr + (%cs.ctr - 1)))) %cs.file
      if (%cs.text != $null) {
        drawtext -npb $chess.window 15 1 system 9 10 $calc(379 + (13 * (4 - %cs.ctr))) %cs.text
    } }
    chess.set sb.ctr %sb.ctr
    .drawdot $chess.window | return
  }
  ; === Clear Scrolbar ===
  drawrect -fn $chess.window 1 1 $cs.chess(524 377).sb 15 70
  ; === Draw Box for Up Arrow ===
  drawrect -fn $chess.window 14 1 $cs.chess(525 377).sb 12 12
  drawline -rn $chess.window $rgb(191,191,191) 1 $cs.chess(526 387 526 378 536 378).sb
  drawline -rn $chess.window $rgb(83,83,83)  1 $cs.chess(526 388 536 388 536 377).sb
  ; === Draw Up Arrow ===
  drawline -n $chess.window 1 1 $cs.chess(529 384 534 384).sb
  drawline -n $chess.window 1 1 $cs.chess(530 383 533 383).sb
  drawdot -n $chess.window 1 1 $cs.chess(531 382).sb
  ; === Draw Bar ===
  drawrect -frn $chess.window $rgb(191,191,191) 1 $cs.chess(525 390).sb 12 31
  ; === Draw Down Arrow Box ===
  drawrect -fn $chess.window 14 1 $cs.chess(525 421).sb 12 12
  drawline -rn $chess.window $rgb(83,83,83) 1 $cs.chess(536 422 536 432 525 432).sb
  drawline -rn $chess.window $rgb(191,191,191) 1 $cs.chess(535 422 526 422 526 432).sb
  ; === Draw Down Arrow ===
  drawline -n $chess.window 1 1 $cs.chess(529 426 534 426).sb
  drawline -n $chess.window 1 1 $cs.chess(530 427 533 427).sb
  drawdot $chess.window 1 1 $cs.chess(531 428).sb
}
alias -l chess.draw {
  if ($1 == -d) { drawdot $chess.window | return }
  if ($1 == -n) { var %cs.n = $true | tokenize 32 $2- }
  if ($1 == -p) {
    tokenize 32 $2- | var %chess.wh = $cs.chess($5-6).wh
    drawpic $iif(%cs.n, -cnst, -cst) @CS_Chess $cs.chess(rgb) $cs.chess(-p,$1-2).xy %chess.wh $cs.chess(-p,$3-4).xy %chess.wh $chess.bmp
    return 
  }
  if ($numtok($1-,32) != 6) { echo -s * Error: chess.draw - Not Enough parms. ( $1- ) | halt }
  var %chess.wh = $cs.chess($5-6).wh | var %cs.r = $iif($window(-1).x == 800, $true, $false)
  drawpic -cnst $chess.window $cs.chess(rgb) $cs.chess($1-2).xy %chess.wh $cs.chess(-p,$cs.chess($cs.chess($1-2).sq).key).xy %chess.wh $chess.bmp
  drawpic $iif(%cs.n, -cnst, -cst) $chess.window $cs.chess(rgb) $cs.chess($1-2).xy %chess.wh $cs.chess(-p,$3-4).xy %chess.wh $chess.bmp
}
alias -l chess.pick {
  ; %chess.click %chess.lastdraw %chess.tmp %chess.last
  window -Cdhopk0 +l @CS_Chess 1 1 233 69
  drawfill -r @CS_Chess 0 0 0 0
  chess.draw -p 1 1 7 2 1 1 | chess.draw -p 3 1 7 2 1 1 | chess.draw -p 5 1 7 2 1 1
  chess.draw -p 2 1 7 1 1 1 | chess.draw -p 4 1 7 1 1 1
  var %chess.gone = $cs.chess(gone)

  if ($cs.chess(self) == b) {
    if (r isin %chess.gone) { chess.draw -p 1 1 $cs.chess(R).key 1 1 }
    if (n isin %chess.gone) { chess.draw -p 2 1 $cs.chess(N).key 1 1 }
    if (b isin %chess.gone) { chess.draw -p 3 1 $cs.chess(B).key 1 1 }
    if (q isin %chess.gone) { chess.draw -p 4 1 $cs.chess(Q).key 1 1 }
  }
  if ($cs.chess(self) == w) {
    if (r isin %chess.gone) { chess.draw -p 1 1 $cs.chess(r).key 1 1 }
    if (n isin %chess.gone) { chess.draw -p 2 1 $cs.chess(n).key 1 1 }
    if (b isin %chess.gone) { chess.draw -p 3 1 $cs.chess(b).key 1 1 }
    if (q isin %chess.gone) { chess.draw -p 4 1 $cs.chess(q).key 1 1 }
  } | chess.set parms $1-5
  chess.send text 12*** $iif($5 == b, Black, White) Picking replacment for Pawn
}
alias -l chess.disp {
  tokenize 32 $cs.chess(mouse.click) $1-
  var %chess.lastdraw = $cs.chess(last.draw)
  if ($cs.chess(draw.flag)) {
    if ($1-2 == $3-4) { chess.set draw.flag $flase }
    var %chess.tmp = $iif($cs.chess(%chess.lastdraw).p,$ifmatch, $cs.chess(%chess.lastdraw).sq)
    chess.draw -n %chess.lastdraw $cs.chess(%chess.tmp).key 1 1
    edit.map inplay $replace(%chess.tmp,1,0) %chess.lastdraw
  }
  else { chess.set draw.flag $true }
  chess.set last.draw $3-4
  var %chess.tmp = $cs.chess($1-2).p
  chess.draw -n $3-4 $cs.chess(%chess.tmp).key 1 1
  edit.map inplay %chess.tmp $3-4
  chess.draw -d
}
alias -l chess.move {
  ; chess.move x y x y b/w
  if ($chess.window != $active) || (!$appactive) { beep }

  ; === Define Vars ===
  var %chess.p1 = $cs.chess($1-2).p
  var %chess.p2 = $cs.chess($3-4).p
  var %cs.self = $replace($cs.chess(self),c,w)
  var %cs.tmp = $iif($cs.chess(self) == b, $true)
  var %cs.tmp.1 = $iif($5 == %cs.self, $true)

  ; === Hilight Nick for Turn ===
  drawtext -pb $chess.window 15 1 system 9 384 164 $iif(%cs.tmp.1, $+(15,$chr(44),12)) $+ $iif(%cs.tmp, $cs.chess(white), $cs.chess(black))
  drawtext -pb $chess.window 15 1 system 9 384 213 $iif(!%cs.tmp.1, $+(15,$chr(44),12)) $+ $iif(%cs.tmp, $cs.chess(black), $cs.chess(white))

  ; === Check if other player used pawn replacment ===
  if ($5 != $cs.chess(self)) && ($6) {
    var %cs.map = $cs.chess(map)
    var %cs.tok = $gettok(%cs.map,$2,59)
    var %cs.tok = $left(%cs.tok,$calc($1 - 1)) $+ $6 $+ $right(%cs.tok,$+(-,$1))
    chess.set map $puttok(%cs.map,%cs.tok,$2,59)
    var %chess.p1 = $cs.chess($1-2).p | var %chess.p2 = $cs.chess($3-4).p
  }

  ; === Edit Map ===
  chess.draw $1-2 $cs.chess($cs.chess($1-2).sq).key 1 1
  if ($5 != $cs.chess(self)) {
    chess.draw $3-4 $cs.chess($cs.chess($3-4).sq).key 1 1
    chess.draw $3-4 $cs.chess(%chess.p1).key 1 1
  }
  chess.set map.inplay $cs.chess(map)
  edit.map inplay %chess.p1 $3-4 | edit.map inplay 0 $1-2

  ; === Check for Casteling ===
  var %cs.dx = $calc($3 - $1))
  if (%chess.p1 == k) && ($abs(%cs.dx) > 1) {
    var %cs.rx = $iif(%cs.dx > 0, 8, 1) | var %cs.rx2 = $calc($1 $iif(%cs.rx == 1, -, +) 1)
    var %cs.rxy = %cs.rx $2 | var %cs.rxy2 = %cs.rx2 $2 | var %chess.p3 = $cs.chess(%cs.rxy).p
    chess.draw %cs.rxy $cs.chess($cs.chess(%cs.rxy).sq).key 1 1
    chess.draw %cs.rxy2 $cs.chess(%chess.p3).key 1 1
    edit.map inplay %chess.p3 %cs.rxy2
    edit.map inplay 0 %cs.rxy
  }

  ; === Save Map Changes ===
  chess.set map $cs.chess(map.inplay)

  ; === Check to see if your in check ===
  if ($chess.check(%cs.self,$cs.chess($iif(%cs.self == b, K, k)).loc)) {
    drawtext -pb $chess.window 4 1 System 8 422 360 You're In Check!
  } | else { drawrect -f $chess.window 1 1 422 360 120 14 }

  ; === Set Turn ===
  chess.title Turn: $iif($5 == b, White, Black) -:- Last Move: $cs.chess($1-2).point to $cs.chess($3-4).point
  chess.set turn $iif($5 == b, w, b)

  ; === Edit Dead List ===
  if (%chess.p2) {
    chess.dead -a $cs.chess(turn) %chess.p2
    if ($cs.chess(turn) == $cs.chess(self)) {
      chess.set gone $addtokcs($cs.chess(gone),%chess.p2,59)
    }
  }

  ; === Self Move ===
  if ($5 == $cs.chess(self)) {
    if (%chess.p2 != k) {
      ; === Castling Flags ===
      if (%chess.p1 == k) { if (!$cs.chess(k.move)) { chess.set k.move $true } }
      if (%chess.p1 == r) {
        var %cs.r = $+(r,$gettok($1-2,1,32),.move)
        if (!$cs.chess(%cs.r)) { chess.set %cs.r $true }
      }
      ; === Pawn Replacment ===
      if ($4 == 1) && (%chess.p1 == p) {
        if ($remove($cs.chess(gone),p,;)) { chess.pick $1- | return }
      }
      ; === Check for Check ===
      if ($chess.check($cs.chess(turn),$cs.chess($iif($cs.chess(turn) == b, K, k)).loc)) {
        if (!$cs.chess(check.flag)) {
          chess.set check.flag $true
          if ($cs.chess(server)) { chess.text -s $+(<,$cs.chess(nick),>) 4Check! }
          else { chess.send TEXT $+(<,$cs.chess(nick),>) 4Check! }
        }
      }
      else { chess.set -r check.flag }
    }
    ; === Send Details ===
    chess.send move $iif($cs.chess(self) == b, $cs.chess($1-4).convert, $1-4) $5-

  }
  else {
    if (%chess.p1 == p) && ($calc($4 - $2) == 2) { chess.set el.pasant $true }
    else { chess.set -r el.pasant }
  }
  ; === Check for winner ===
  if (%chess.p2 == k) { chess.win $5 }
}
alias chess.title {
  if (!$window($chess.window)) { return }
  titlebar :: Teens Script :: $chess.window :: $iif($1, -) $1- 
  if ($7 == to) {
    var %chess.tmp = $+(move.hist.,$iif($2 == Black, w, b))
    var %chess.hist = $cs.chess(%chess.tmp)
    var %chess.hist = $instok(%chess.hist,$+($6,.,$8),$calc($numtok(%chess.hist,59) + 1),59)
    chess.set %chess.tmp %chess.hist
    chess.move.tbl
  }
}
alias -l chess.set {
  if (!$hget(chess)) { .hmake chess 10 }
  if ($1 == -r) {
    var %cs.ctr = 0 | var %cs.tot = $numtok($2-,32)
    while (%cs.ctr < %cs.tot) { inc %cs.ctr | .hdel -w chess $gettok($2-,%cs.ctr,32) }
    return
  }
  if ($1 == -i) { .hadd chess $2 $calc($hget(chess,$2) + 1) }
  else { .hadd chess $1 $2- }
}
alias -l edit.map {
  ; edit.map map peice x y
  var %cs.map.n = map. $+ $1 | var %cs.map = $cs.chess(%cs.map.n)
  var %cs.tok = $gettok(%cs.map,$4,59)
  var %cs.tok = $left(%cs.tok,$calc($3 - 1)) $+ $2 $+ $right(%cs.tok,$calc($3 * -1))
  chess.set %cs.map.n $puttok(%cs.map,%cs.tok,$4,59)
}

alias -l chess.setup {
  chess.set map $chess.map($1)
  chess.board -c | chess.board -s
  chess.set self $remove($1,-)
}
alias -l chess.server {
  if ($sock(*chess*)) { sockclose *chess* }
  chess.raw 003 $+(@,$cs.chess(nick))
  chess.set server $true | chess.set user.num s
  chess.set user.nick $cs.chess(nick)
  socklisten CHESS $cs.chess(port)
  chess.text 12*** Server Started on port $cs.chess(port)
  chess.title Server is Listening for Connections.
  chess.lights
}
alias -l chess.client {
  chess.board -c
  if ($sock(*chess*)) { sockclose *chess* }
  var %chess.host = $readini $chess.ini save host
  if (!$1) {
    if ($chess.get(host)) { chess.set input $ifmatch }
    chess.set prompt Enter Host or IP Address: 
    tokenize 32 $$dialog(CS_Input,CS_Input,-3)
  }
  writeini $chess.ini save host $$1 | chess.set host $$1
  chess.title Searching for host.... | sockopen CS.CHESS $$1 $cs.chess(port)
  chess.lights
}

alias -l chess.win {
  if ($cs.chess(game)) {
    chess.text 12*** $iif($1 == b, Black, White) Player Wins! - Game Over
    chess.set -r game turn self gone move.hist.* white black
    chess.title Game Over - $iif($1 == b, Black, White) is the Winner
    drawrect -f $chess.window 1 1 422 360 120 14 | chess.lights
} }
alias -l chess.close {
  if ($cs.chess(server)) {
    chess.title Dssconnected
    chess.set -r game turn self move.hist.* server
    chess.send CLOSE | sockclose *chess*
  }
  if ($sock(*chess*,1)) { sockclose *chess* }
  if ($hget(chess)) { .hfree chess }
  unset %chess.* | close -@ $chess.window
}
alias -l chess.game {
  chess.set prompt Save As? | chess.set -r input
  var %chess.name = $+(cs.,$$dialog(CS_Input,CS_Input,-3),.csg) | window -a $chess.window
  ; === Save Game ===
  if (!$isdir($+($scriptdir,saved\))) { mkdir $+($scriptdir,saved\) }
  ; if ($1 == -s) { if ($hget(chess,1).item) { .hsave -bo chess $+($scriptdir,saved\,%chess.name) } }
  ; if ($1 == -l) { if (!$hget(chess)) { .hmake chess 15 } }
}

alias -l chess.multitext {
  var %cs.file = $+(",$scriptdirchess.log,")
  var %k = $chr(160) $+ $iif($left($1,1) == , $left($1,$len($remove($1,$strip($1)))))
  var %ctr = 0 | var %tot = $0
  while (%ctr < %tot) {
    inc %ctr | var %tok = $gettok($1-,%ctr,32)
    var %string = %string %tok
    if ($width(%string,system,9,0,1) > $cs.chess(510).sb) {
      if ($numtok(%string,32) <= 2) { var %string = $left(%string,60) | break }
      .write %cs.file $gettok(%string,$+(1-,$calc($numtok(%string,32) - 1)),32)
      var %string = $+(%k,%tok)
    }
  }
  chess.text %string
}
alias -l chess.text.hilight {
  if (!$cs.chess(sb.ctr)) { chess.set sb.ctr 0 }
  var %cs.line = $calc(4 - $int($calc(($3 - 380) / 13)))
  var %cs.file = $+(",$scriptdirchess.log,")
  var %sb.ctr = $cs.chess(sb.ctr)
  var %sb.tot = $lines(%cs.file)
  if (!$exists(%cs.file)) || (%cs.line !isnum 1-4) { return }
  if ($1 == -s) {
    var %cs.text = $read $+(-nl,$calc(%sb.tot - (%sb.ctr + (%cs.line - 1)))) %cs.file
    var %cs.text = $replace(%cs.text,$chr(32),$chr(160))
    var %cs.ctr = 0 | var %cs.tot = $len(%cs.text)
    chess.set hl.line %cs.line | chess.set hl.flag $true
    while (%cs.ctr < %cs.tot) {
      inc %cs.ctr | var %cs.string = $left(%cs.text,%cs.ctr)
      if ($width($replace(%cs.string,$chr(160),$chr(32)),system,9,1,1) > $calc($2 - 10)) {
        var %cs.string = $left(%cs.string,-1) | var %cs.string = $+(%cs.string,,$remove(%cs.text,%cs.string))
        chess.set hilight $true | chess.set hl.string %cs.string | break
      }
    } | return
  }
  if ($1 == -h) {
    if ($cs.chess(hl.flag)) { chess.set -r hl.flag | clipboard } | :h
    var %cs.line = $calc(4 - $int($calc(($3 - 380) / 13)))
    var %cs.text = $cs.chess(hl.string) | var %cs.tmp.ctr = 0
    var %cs.ctr = $iif($left(%cs.text,1) == , 0, $len($strip($gettok(%cs.text,1,$asc())))) | var %cs.tot = $len(%cs.text)
    while (%cs.line < $cs.chess(hl.line)) {
      inc %cs.tmp.ctr | inc %chess.hl.ctr
      clipboard -a $+($strip($gettok($replace(%cs.text,$chr(160),$chr(32)),$iif($left(%cs.text,1) == , 1, 2),$asc())),$crlf)
      chess.set $iif(%chess.hl.ctr > 1, $+(hl.fstring.,%chess.hl.ctr), hl.fstring) %cs.text
      drawtext -pb $chess.window 15 1 system 9 10 $calc(379 + (13 * (4 - $cs.chess(hl.line)))) $replace(%cs.text,$chr(160),$chr(32),,$+(1,$chr(44),15))
      var %cs.text =  $+ $read $+(-nl,$calc(%sb.tot - (%sb.ctr + $cs.chess(hl.line) -2))) %cs.file
      var %cs.text = $replace(%cs.text,$chr(32),$chr(160))
      chess.set hl.line $calc($cs.chess(hl.line) - 1) | chess.set hl.string %cs.text
    }
    if (%cs.tmp.ctr > 0) { chess.set hl.width 10 | goto h }
    while (%cs.ctr < %cs.tot) {
      inc %cs.ctr | var %cs.string = $left(%cs.text,%cs.ctr)
      var %cs.width = $width($replace(%cs.string,$chr(160),$chr(32)),system,9,1,1) 
      if (%cs.width > $calc($2 - 10)) {
        if (%cs.width == $cs.chess(hl.width)) { return }
        var %cs.string = $+(%cs.string,,$remove(%cs.text,%cs.string))
        if (%cs.ctr == %cs.tot) { var %cs.tstring = $replace(%cs.string,$chr(160),$chr(32),,$+(1,$chr(44),15)) }
        drawtext -pb $chess.window 15 1 system 9 10 $calc(379 + (13 * (4 - $cs.chess(hl.line)))) $iif(%cs.tstring, %cs.tstring, $replace(%cs.string,$chr(160),$chr(32)))
        chess.set hl.width %cs.width | chess.set hl.fstring %cs.string | return
      }
    }
  }
}
alias -l chess.text {
  tokenize 32 $left($1-,400)
  if ($1 == -s) {
    tokenize 32 $2-
    if ($cs.chess(server)) { if ($sock(cs.chess*,1)) { chess.send -a TEXT $1- } }
  }
  if ($width($1-,system,9,0,1) > $cs.chess(505).sb) { chess.multitext $1- | return }
  if ($active != $chess.window) { window -g1 $chess.window }
  var %cs.file = $+(",$scriptdirchess.log,") | write %cs.file $1-
  if ($cs.chess(sb.flag)) { chess.set -i sb.ctr | return }
  drawrect -rf $chess.window $rgb(0,0,0) 1 1 379 $cs.chess(523).sb 70
  var %ctr = 0 | var %tot = $lines(%cs.file)
  while (%ctr < 4) {
    inc %ctr | var %cs.tmp = $calc(%ctr - 1)
    chess.set $+(text_,%ctr) $read $+(-nl,$calc(%tot - (%ctr - 1))) %cs.file
  }
  var %cs.ctr = 0
  while (%cs.ctr < 4) {
    inc %cs.ctr | var %cs.text = $cs.chess($+(text_,%cs.ctr))
    if (%cs.text != $null) {
      drawtext -npb $chess.window 15 1 system 9 10 $calc(379 + (13 * (4 - %cs.ctr))) $cs.chess($+(text_,%cs.ctr))
  } }
  .drawdot $chess.window
}

; =================
;            Sockets
; =================
on 1:SOCKLISTEN:CHESS: {
  ; === Chess.Server ===
  chess.text 12*** Connection Attempt from $iif($sock($sockname).ip, $ifmatch, UnKnown) ( $+ $sock($sockname).port $+ )
  chess.set -i client.ctr | sockaccept $+(TMP.CHESS.,$cs.chess(client.ctr))
}
on 1:SOCKOPEN:CS.CHESS: {
  ; === Chess.Client ===
  if ($sockerr > 0) {
    chess.title Not Connected
    var %cs.sock.err = $iif($sockerr == 4, Unable to resolve Server, $iif($sockerr == 3, Connection Timed Out, Unknown))
    chess.text 12*** Unable to Connect ( $+ %cs.sock.err $+ ) | return
  }
  chess.title Host Found, Connecting....
  chess.send USER $+(CS.CHESS,$chess.version) $cs.chess(nick)
}
on 1:SOCKCLOSE:CS.CHESS*: {
  if ($cs.chess(server)) {
    if ($cs.chess(-nick,$gettok($sockname,3,46)).user) { chess.rcvd $encode(QUIT Connection reset by peer) }
  }
  else { chess.title - Not Connected | chess.text 4*** Disconnected From Server }
  chess.lights
}
on 1:SOCKREAD:*.CHESS*: {
  if ($sockerr > 0) { return } | :read.next
  if (!$sock($sockname)) { return }
  sockread %chess.read
  if ($sockbr == 0) { return }
  if (%chess.read == $null) { %chess.read = - }
  chess.rcvd %chess.read | goto read.next
}
alias -l chess.send {
  var %chess.sock = $iif(($sockname) && ($1 != -a), $sockname, CS.CHESS*)
  if (cs.chess.* iswm $1) { var %chess.sock = $1 | tokenize 32 $2- }
  if ($1 == -a) { if (!$sock(cs.chess*)) { return } | tokenize 32 $2- }
  var %chess.send = $upper($$1) $2- | chess.lights -b
  if ($cs.chess(debug)) { echo -s * -> %chess.sock %chess.send }
  if ($sock(%chess.sock)) { sockwrite -nt %chess.sock $encode(%chess.send) }
}
alias -l chess.rcvd {
  chess.lights -b | tokenize 32 $decode($1-)
  if ($cs.chess(debug)) { echo 4 -s * $1- }
  var %user.num = $gettok($sockname,3,46)
  var %user.nick = $iif(tmp.* !iswm $sockname, $cs.chess(-nick,%user.num).user)
  if ($1 == USER) {
    if ($left($2,8) == cs.chess) {
      tokenize 32 $remove($2,cs.chess) $3-
      if ($round($1,1) == $round($chess.version,1)) {
        if ($istok($cs.chess(user.nick),$2,59)) { tokenize 32 $1 $+($2,.,%user.num) $3- | chess.send raw 009 $2 }
        chess.set user.num $addtok($cs.chess(user.num),%user.num,59)
        chess.set user.nick $addtok($cs.chess(user.nick),$2,59)
        chess.send -a JOIN $2 | chess.text 3*** Joins: $2 | chess.send auth +OK
        if ($sock(CS.CHESS.*,1)) { sockwrite -nt CS.CHESS.* JOIN $2 }
        chess.send -a RAW 003 $sorttok($addtok($cs.chess(names),$2,32),32)
        chess.raw 003 $sorttok($addtok($cs.chess(names),$2,32),32)
        sockrename $sockname $replace($sockname,TMP,CS)
      }
      else { chess.send ERR Server is runing version $chess.version }
    }
  }
  if ($1 == ERR) {
    sockclose *chess* | chess.title Not Connected
    chess.text 12*** Error: $2- | halt
  }
  if ($1 == AUTH) {
    chess.send NAMES | chess.send GAME | chess.lights
    var %cs.txt = Connected to $sock($sockname).ip ( $+ $sock($sockname).port $+ )
    chess.title %cs.txt | chess.text 12*** %cs.txt
  }
  if ($1 == NAMES) { chess.send RAW 003 $cs.chess(names) }
  if ($1 == GAME) {
    chess.send RAW 004 $iif($cs.chess(game), Active, InActive) $cs.chess(black) $cs.chess(white)
    if ($cs.chess(self) == b) {
      var %cs.map1 = $cs.chess(map) | var %cs.map
      var %ctr = 0 | var %tot = $len(%cs.map1)
      while (%ctr < %tot) { inc %ctr | var %cs.map = $+(%cs.map,$mid(%cs.map1,$+(-,%ctr),1)) }
    }
    else { %cs.map = $cs.chess(map) }
    chess.send RAW 005 $iif($cs.chess(game), %cs.map)
    if ($cs.chess(game)) {
      chess.send RAW 007 $cs.chess(move.hist.b) $cs.chess(move.hist.w)
      chess.send RAW 008 $cs.chess(dead.b) $cs.chess(dead.w)
      chess.send RAW 011 $cs.chess(turn)
    }
  }
  if ($1 == RAW) { chess.raw $2- }
  if ($1 == JOIN) { chess.text -s 3*** Joins: $2 }
  if ($1 == TEXT) { chess.text -s $2- }
  if ($1 == QUIT) { :quit
    chess.set user.num $remtok($cs.chess(user.num),%user.num,1,59)
    chess.set user.nick $remtok($cs.chess(user.nick),%user.nick,1,59)
    chess.set names $remtok($cs.chess(names),%user.nick,32)
    chess.raw 003 $cs.chess(names) | .sockclose $sockname
    chess.text -s 12*** Quits: %user.nick ( $+ $iif($2, $2-, QUIT: User Exited) $+ )
    chess.send RAW 003 $cs.chess(names)
    if ($cs.chess(white) == %user.nick) || ($cs.chess(black) == %user.nick) {
      if ($cs.chess(server)) { chess.send raw 006 | chess.raw 006 }
    }
  }
  if ($1 == CLOSE) {
    if ($cs.chess(server)) { goto quit } | chess.text 4*** Disconnected
    sockclose *chess* | chess.title Disconnected | chess.raw 003 | chess.lights
  }
  if ($1 == CHALLENGE) {
    if ($cs.chess(server)) { :challenge
      if ($cs.chess(game)) { chess.send text 12*** Game Already in Progress | return }
      if ($istok(Accecpt;Decline,$2,59)) {
        if ($2 == Accecpt) {
          var %cs.rand = $rand(1,2)
          var %chess.b = $iif(%cs.rand == 1, %user.nick, $3)
          var %chess.w = $iif(%cs.rand == 2, %user.nick, $3)
          chess.send -a raw 004 Active %chess.b %chess.w
          chess.send -a raw 005 $chess.map(-w)
          chess.send -a raw 011 w
          chess.raw 004 Active %chess.b %chess.w
          chess.raw 005 $chess.map(-w) | chess.raw 011 w
        } | chess.text -s 12*** %user.nick $+($2,'s) Challenge | return
      }
      else {
        chess.text 12*** $2 Challenges $3
        chess.send -a $1 $2 $3
        if ($3 == $cs.chess(nick)) {
          chess.set prompt Do you wish to play $+($2,?)
          tokenize 32 $1 $iif($dialog(CS_Prompt,CS_Prompt,-3) == Yes, Accecpt, Decline) $2
          var %user.num = s | var %user.nick = $cs.chess(nick) | goto challenge
        }
    } }
    else {
      chess.text 12*** $2 Challenges $3
      if ($3 == $cs.chess(nick)) {
        chess.set prompt Do you wish to play $+($2,?) 
        chess.send $1 $iif($dialog(CS_Prompt,CS_Prompt,-3) == Yes, Accecpt, Decline) $2
    } }
  }

  if ($1 == MOVE) {
    if ($cs.chess(server)) { chess.send -a $1- }
    if ($6 != $cs.chess(self)) { chess.move $iif($cs.chess(self) == b, $cs.chess($2-5).convert, $2-5) $6- }
  }
}
alias -l chess.raw {
  if ($1 == 002) { chess.setup $2 }
  if ($1 == 003) {
    ; === Names Raw ===
    chess.set names $2- | var %ctr = 0 | var %tot = $numtok($2-,32)
    dline -l $chess.window $+(1-,$line($chess.window,0,1))
    while (%ctr < %tot) { inc %ctr | aline -l $chess.window $gettok($2-,%ctr,32) }
  }
  if ($1 == 004) {
    if ($2 == Active) {
      chess.set black $3 | chess.set white $4 | chess.set game $true
      ; cline 14 $chess.window $3 | cline 0 $chess.window $4
      if ($istok($3-4,$cs.chess(nick),32)) {
        if ($3 == $cs.chess(nick)) { chess.set map $chess.map(-b) | chess.set self b }
        if ($4 == $cs.chess(nick)) { chess.set map $chess.map(-w) | chess.set self w }
        chess.board -c | chess.board -s
      }
      else { chess.set self c } | var %cs.tmp = $iif($cs.chess(self) == b, $true)
      drawtext -npb $chess.window 15 1 system 9 384 164 $iif(%cs.tmp, $4, $3)
      drawtext -npb $chess.window 15 1 system 9 384 213 $iif(%cs.tmp, $3, $4)
      chess.draw -d
    }
  }
  if ($1 == 005) { 
    if ($cs.chess(self) == c) { chess.board -c | chess.set map $2- | chess.board -s }
  }
  if ($1 == 006) {
    chess.set -r game white black turn self move.hist.*
    chess.board -c | chess.lights | chess.title
  }
  if ($1 == 007) { if ($3) { chess.set move.hist.b $2 | chess.set move.hist.w $3 | chess.move.tbl -down } }
  if ($1 == 008) {
    if ($3) {
      chess.dead -c | tokenize 32 $remove($2-,0)
      var %ctr = 0 | var %tot = $numtok($1,59)
      while (%ctr < %tot) { inc %ctr | chess.dead -a b $gettok($1,%ctr,59) }
      var %ctr = 0 | var %tot = $numtok($2,59)
      while (%ctr < %tot) { inc %ctr | chess.dead -a w $gettok($2,%ctr,59) }
  } }
  if ($1 == 009) { chess.set nick $2 }
  if ($1 == 011) {
    ; === Define Vars ===
    var %cs.self = $replace($cs.chess(self),c,w)
    var %cs.tmp = $iif($cs.chess(self) == b, $true)
    var %cs.tmp.1 = $iif($2 != %cs.self, $true)

    ; === Hilight Nick for Turn ===
    drawtext -pb $chess.window 15 1 system 9 384 164 $iif(%cs.tmp.1, $+(15,$chr(44),12)) $+ $iif(%cs.tmp, $cs.chess(white), $cs.chess(black))
    drawtext -pb $chess.window 15 1 system 9 384 213 $iif(!%cs.tmp.1, $+(15,$chr(44),12)) $+ $iif(%cs.tmp, $cs.chess(black), $cs.chess(white))

    if ($active != $chess.window) { window -g1 $chess.window }
    if ($2 isin bw) { chess.title Turn: $iif(b isin $2, Black, White) | chess.set turn $2 }
  }
  if ($1 == 013) { chess.dead $2- }
}

; =================
;        Remotes
; =================
on 1:INPUT:@Chess*: {
  if (($left($1,1) != /) || ($1 == /say)) { var %cs.txt = $+(<,$cs.chess(nick),>) $1- } 
  if ($1 == //say) { var %cs.txt = $+(<,$cs.chess(nick),>) $eval($2-,2) }
  if ($1 == //me) { var %cs.txt = 13* $cs.chess(nick) $eval($2-,2) }
  if ($1 == /me) { var %cs.txt = 13* $cs.chess(nick) $2- }
  if (%cs.txt) {
    if ($cs.chess(server)) { chess.text -s %cs.txt | halt }
    if (!$sock(cs.chess*,1)) { chess.text %cs.txt | halt }
    else { chess.send TEXT %cs.txt | halt }
  }
}
on 1:CLOSE:@Chess*: { chess.close }
ctcp 1:VERSION:*: {
  .ctcpreply $nick ADDON CS Chess $+(v,$chess.version) by Cobra^ (#mIRC / WebNet) 12* 11http://webmirc.cjb.net
}

; =================
;       Identifers
; =================
alias chess.bmp { return $+(",$scriptdirchess.bmp,") }
alias chess.ini { return $+(",$scriptdirchess.ini,") }
alias chess.window { return $+(@Chessv,$chess.version) }
alias chess.version { return 1.56 }
alias chess.get { return $readini $chess.ini save $1 }
alias -l chess.map {
  if ($1 == -b) { return rnbkqbnr;pppppppp;00000000;00000000;00000000;00000000;PPPPPPPP;RNBKQBNR }
  if ($1 == -w) { return RNBQKBNR;PPPPPPPP;00000000;00000000;00000000;00000000;pppppppp;rnbqkbnr }
  if ($1 == -k) { return RNBQKP0;rnbqkp1 }
}
alias -l chess.valid {
  goto $$1 | :r | return 0,*;*,0 | :n | return 2,1;1,2 | :b | return N,N
  :k | return 1,0;0,1;1,1 | :q | return 0,*;*,0;N,N | :p | return 0,1;0,2;1,1
}
alias -l chess.mouse {
  if ($1 == -p) { var %cs.p = $true }
  if (!%cs.p) { if ($mouse.x !isnum 17-376) || ($mouse.y !isnum 17-376) { return } }
  var %mouse.x = $calc($int($calc(($mouse.x - $iif(%cs.p, 0, 17)) / 45)) + 1)
  var %mouse.y = $calc($int($calc(($mouse.y - $iif(%cs.p, 0, 17)) / 45)) + 1)
  if (!%cs.p) { chess.set mouse.old $cs.chess(mouse) | chess.set mouse %mouse.x %mouse.y }
  return %mouse.x %mouse.y
}
alias -l chess.vmove {
  ; chess.vmove x y
  tokenize 32 $cs.chess(mouse.click) $1-
  var %chess.p = $cs.chess($1-2).p
  var %chess.valid = $chess.valid(%chess.p)
  var %cs.dx = $abs($calc($3 - $1))
  var %cs.dy = $abs($calc($4 - $2))
  var %cs.dxy = %cs.dx $+ , $+ %cs.dy
  var %chess.wb = $cs.chess($3-4).wb
  var %chess.attack = $iif((%chess.wb != $null) && (%chess.wb != $cs.chess(self)), $true)
  if (%cs.dxy == 0,0) { return $true }
  if (%chess.wb == $cs.chess(self)) { return $false }

  ; === Check if valid move for pawn ===
  if (%chess.p == p) {
    if ($calc($2 - $4) > 0) {
      if (%chess.attack) { if (%cs.dxy == 1,1) { goto path.chk } }
      else { if (%cs.dxy == 0,1) || ((%cs.dxy == 0,2) && ($2 == 7)) { goto path.chk } }
    } | return $false
  }

  ; === Check Castling ===
  if (%chess.p = k) && (%cs.dxy == 2,0) {
    ; === Check to make sure King and Rook have not moved ===
    if (!$cs.chess(k.move)) {
      var %cs.rn = $+(r,$iif($3 < $1, 1, 2))
      if (!$cs.chess($+(%cs.rn,.move))) {
        ; === Check to see if King would be in Check from either 3 spots ===
        var %ctr = 0 | var %tot = 3
        while (%ctr < %tot) {
          inc %ctr | var %cs.tmp.xy = $calc($1 $iif(%cs.r == 1, -, +) (%ctr - 1)) $2
          if ($chess.check($cs.chess(self),%cs.tmp.xy)) { return $false }
        }
        ; === Check to see if any peices are between king and rook ===
        tokenize 32 $1-2 $iif(%cs.rn == r1, 1 8, 8 8)
        var %cs.dx = $abs($calc($3 - $1))
        var %cs.dy = $abs($calc($4 - $2))
        var %cs.dxy = %cs.dx $+ , $+ %cs.dy
        var %cs.castle = $true | goto path.chk
      }
    } | return $false
  }

  ; === Check other peice valid moves ===
  var %chess.ctr = 0 | var %chess.tot = $numtok(%chess.valid,59)
  while (%chess.ctr < %chess.tot) {
    inc %chess.ctr | var %chess.tok = $gettok(%chess.valid,%chess.ctr,59)
    if (%chess.tok == %cs.dxy) || (%chess.tok iswm %cs.dxy) { goto path.chk }
    if ((%chess.tok == N,N) && (%cs.dx == %cs.dy)) { goto path.chk }
  } | return $false

  ; === Check Path ===
  :path.chk
  if ((%cs.dx <= 1) && (%cs.dy <= 1)) || (%chess.p == n) { return $true }  
  var %cs.x.inc = $iif($1 == $3, +0, $iif($1 < $3, +1, -1))
  var %cs.y.inc = $iif($2 == $4, +0, $iif($2 < $4, +1, -1))
  var %cs.x.cord = $1 | var %cs.y.cord = $2
  var %chess.ctr = 0 | var %chess.tot = $calc($iif((%cs.dx == %cs.dy) || (%cs.dy == 0), %cs.dx, %cs.dy) - 1)
  while (%chess.ctr < %chess.tot) {
    inc %chess.ctr
    var %cs.x.cord = $calc(%cs.x.cord %cs.x.inc)
    var %cs.y.cord = $calc(%cs.y.cord %cs.y.inc)
    var %cs.xy.cord = %cs.x.cord %cs.y.cord
    if ($cs.chess(%cs.xy.cord).p != $null) { return $false }
  }
  chess.set castle $iif(%cs.castle, $true, $false) | return $true
}
alias chess.check {
  ; chess.check b/w x y
  ; b/w = king color
  ; x y = king position
  tokenize 32 $1-
  ; === Check Paths ===
  var %cs.x = $2 | var %cs.y = $3
  var %chess.vmove = *,0;0,*;N,N
  var %ctr.1 = 0 | var %tot.1 = 3
  while (%ctr.1 < %tot.1) {
    inc %ctr.1 | var %cs.vmove = $gettok(%chess.vmove,%ctr.1,59)
    tokenize 32 $1-3 $replace(%cs.vmove,$chr(44),$chr(32))
    var %ctr.sign = 0
    if (%cs.vmove == N,N) { var %tot.sign = 4 | var %cs.x.sign = +;+;-;- | var %cs.y.sign = +;-;+;- }
    else { var %tot.sign = 2 | var %cs.x.sign = +;- | var %cs.y.sign = +;- }
    while (%ctr.sign < %tot.sign) {
      inc %ctr.sign | var %ctr.2 = 0 | var %tot.2 = 7
      var %cs.sign.x = $gettok(%cs.x.sign,%ctr.sign,59)
      var %cs.sign.y = $gettok(%cs.y.sign,%ctr.sign,59)
      while (%ctr.2 < %tot.2) {
        inc %ctr.2
        var %cs.tmp.x = $calc(%cs.x %cs.sign.x $iif($4 != 0, %ctr.2, 0))
        var %cs.tmp.y = $calc(%cs.y %cs.sign.y $iif($5 != 0, %ctr.2, 0))
        if (%cs.tmp.x isnum 1-8) && (%cs.tmp.y isnum 1-8) {
          var %cs.tmp.xy = %cs.tmp.x %cs.tmp.y
          var %chess.p = $cs.chess(%cs.tmp.xy).p
          if (%chess.p isalpha) { var %ctr.2 == %tot.2 }
          if ($asc(%chess.p) isnum $iif($1 == b, 97-122, 65-90)) {
            ; === Check to see if peice can kill me ===
            var %chess.vchk = $chess.valid(%chess.p)
            if ($istok(%chess.vchk,%cs.vmove,59)) { return $true }
            if (%chess.p isin kp) {
              var %cs.dx = $calc(%cs.tmp.x - $2)
              var %cs.dy = $calc(%cs.tmp.y - $3)
              var %cs.dxy = $+($abs(%cs.dx),$chr(44),$abs(%cs.dy))
              if (%chess.p == k) && (%cs.dxy isin %chess.vchk) { return $true }
              var %cs.dxy = $abs(%cs.dx) %cs.dy
              var %cs.chk = $iif($1 != $iif($cs.chess(self) isin cw, w, b), 1 1, 1 -1)
              if (%chess.p == p) && (%cs.dxy == %cs.chk) { return $true }
        } } }
      }
    }
  }
  ; === Check if Knight can kill you ===
  var %ctr.1 = 0
  while (%ctr.1 < 2) {
    inc %ctr.1 | var %ctr.2 = 0
    while (%ctr.2 < 2) {
      inc %ctr.2 | var %cs.tmp.x = $calc(%cs.x $iif(%ctr.2 == 1, +, -) $iif(%ctr.1 == 1, 2, 1))
      var %ctr.3 = 0
      while (%ctr.3 < 2) {
        inc %ctr.3 | var %cs.tmp.y = $calc(%cs.y $iif(%ctr.3 == 1, +, -) $iif(%ctr.1 == 1, 1, 2))
        if (%cs.tmp.x isnum 1-8) && (%cs.tmp.y isnum 1-8) {
          var %cs.tmp.xy = %cs.tmp.x %cs.tmp.y
          var %chess.p = $cs.chess(%cs.tmp.xy).p
          if (%chess.p === $iif($1 == b, n, N)) {
            return $true
          }
      } }
    }
  } | return $false
}
alias cs.chess {
  if ($isid) {
    ; if ($1 == debug) { return $true }
    if ($prop != $null) {
      if ($prop == xy) {
        if ($1 == -p) { tokenize 32 $2- | var %cs.p = $true }
        var %chess.ctr = 0 | var %chess.string
        while (%chess.ctr < $numtok($1-,32)) {
          inc %chess.ctr | var %chess.val = $gettok($1-,%chess.ctr,32)
          var %chess.string = %chess.string $calc($iif(%cs.p, 0, 18) + ((%chess.val - 1) * 45))
        } | return %chess.string
      }
      if ($prop == wh) {
        var %chess.ctr = 0 | var %chess.string
        while (%chess.ctr < $numtok($1-,32)) {
          inc %chess.ctr | var %chess.val = $gettok($1-,%chess.ctr,32)
          var %chess.string = %chess.string $calc(%chess.val * 45)
        } | return %chess.string
      }
      if ($prop == wb) || ($prop == p) {
        tokenize 32 $1-
        if ($2 == $null) { return }
        var %cs.map = $hget(chess,map)
        var %chess.val = $mid($gettok(%cs.map,$2,59),$1,1)
        if (%chess.val isnum) { return }
        return $iif($prop == wb, $iif($isupper(%chess.val), b, w), %chess.val)
      }
      if ($prop == loc) {
        var %cs.map = $hget(chess,map)
        var %tok = $matchtokcs(%cs.map,$1,1,59)
        var %cs.y = $findtokcs(%cs.map,%tok,1,59)
        var %cs.x = $pos(%tok,$1,1)
        return %cs.x %cs.y
      }
      if ($prop == sq) {
        tokenize 32 $1-
        var %cs.x = $calc($1 / 2) | var %cs.x = $iif(%cs.x == $int(%cs.x), E, O)
        var %cs.y = $calc($2 / 2) | var %cs.y = $iif(%cs.y == $int(%cs.y), E, O)
        return $iif(%cs.y == E, $iif(%cs.x == E, 0, 1), $iif(%cs.x == O, 0, 1))
      }
      if ($prop == key) {
        tokenize 32 $left($1,1)
        var %cs.map = $chess.map(-k)
        var %cs.tok = $matchtokcs(%cs.map,$1,1,59)
        var %cs.y = $findtok(%cs.map,%cs.tok,1,59) | var %cs.x = $pos(%cs.tok,$1,1)
        return %cs.x %cs.y
      }
      if ($prop == convert) {
        var %cs.parms = $1- | var %cs.ctr = 0 | var %cs.string
        var %cs.tot = $numtok(%cs.parms,32)
        while (%cs.ctr < %cs.tot) {
          inc %cs.ctr | var %cs.val = $abs($calc($gettok(%cs.parms,%cs.ctr,32) - 9))
          var %cs.string = %cs.string %cs.val
        } | return %cs.string
      }
      if ($prop == point) {
        tokenize 32 $1- | return $chr($calc($1 + 64)) $+ $2
      }
      if ($prop == pick) {
        return $iif($1 == r, Rook, $iif($1 == n, Knight, $iif($1 == b, Bishop, $iif($1 == q, Queen, Unknown))))
      }
      if ($prop == user) {
        var %user.num.list = $hget(chess,user.num)
        var %user.nick.list = $hget(chess,user.nick)
        if ($1 == -nick) { return $gettok(%user.nick.list,$findtok(%user.num.list,$2,1,59),59) }
        if ($1 == -num) { return $gettok(%user.num.list,$findtok(%user.nick.list,$2,1,59),59) }
      }
      if ($prop == sb) {
        if ($1 == -n) { var %cs.s = - | tokenize 32 $2- }
        else { var %cs.s = + }
        var %cs.dx = $calc($window($chess.window).dw - 538)
        var %cs.dy = $calc($window($chess.window).dh - 434)
        var %cs.ctr = 0 | var %cs.tot = $numtok($1-,32) | var %cs.string
        while (%cs.ctr < %cs.tot) {
          inc %cs.ctr | var %cs.ctr2 = $iif(%cs.ctr2 == 1, 2, 1)
          var %cs.string = %cs.string $calc($gettok($1-,%cs.ctr,32) %cs.s $iif(%cs.ctr2 == 1, %cs.dx, %cs.dy))
        } | return %cs.string
      }
    }
    else { return $hget(chess,$1) }
} }
