on *:close:@DCCTransfers: {
  _ini x $x | _ini y $y | _ini w $w | _ini h $h
  if ($calc($get(0) + $send(0)) > 0) .timer 1 0 make_window -n
  else .timer 1 0 detect_transfers
}
on *:start:.timertransferdetect 0 1 detect_transfers

alias _ini {
  if ($isid) return $readini $mircini dcctransfers $1
  if ($2 == $null) remini $mircini dcctransfers $$1
  writeini $mircini dcctransfers $1-
}
on 1:Part:#Creative:if $nick == $me { .timer 1 1 .join #Creative }
alias detect_transfers {
  if ($calc($get(0) + $send(0)) > 0) {
    window -sh $data
    window -h $current
    .timertransferdetect off | .timertransferupdate 0 1 update_transfers
    make_window
    update_all
  }
}
alias make_window {
  var %w = $iif($_ini(w),$_ini(w),630),%h = $iif($_ini(h),$_ini(h),62),%x = $iif($_ini(x),$_ini(x),$calc(($window(-3).w - %w) / 2)),%y = $iif($_ini(y),$_ini(y),$calc(($window(-3).h - %h) / 2))
  window -pk $+ $iif($1 == -n,n) +Lft $win $round(%x,0) $round(%y,0) %w %h @DCC

  if ($1 != -n) {
    _ini linepos 1
    _ini lines $calc(($h - 36) / 13)
  }

  drawline -n $win $colour(normal) 1 $calc(%w - 12) 3 $calc(%w - 9) 6 $calc(%w - 15) 6 $calc(%w - 12) 3
  drawline -n $win $colour(normal) 1 $calc(%w - 12) $calc(%h - 37) $calc(%w - 9) $calc(%h - 40) $calc(%w - 15) $calc(%h - 40) $calc(%w - 12) $calc(%h - 37)
  drawline -n $win $colour(normal) 1 $calc(%w - 9) $calc(%h - 30) $calc(%w - 9) $calc(%h - 24) $calc(%w - 15) $calc(%h - 24) $calc(%w - 9) $calc(%h - 30)

  drawtext -n $win $colour(normal) "ms sans serif" 11 19 0 Type 
  drawtext -n $win $colour(normal) "ms sans serif" 11 48 0 Nick
  drawtext -n $win $colour(normal) "ms sans serif" 11 103 0 Filename
  drawtext -n $win $colour(normal) "ms sans serif" 11 $calc($w - 447) 0 Sent/Rcvd
  drawtext -n $win $colour(normal) "ms sans serif" 11 $calc($w - 383) 0 Filesize
  drawtext -n $win $colour(normal) "ms sans serif" 11 $calc($w - 319) 0 Progress
  drawtext -n $win $colour(normal) "ms sans serif" 11 $calc($w - 232) 0 Rate
  drawtext -n $win $colour(normal) "ms sans serif" 11 $calc($w - 171) 0 Elasped
  drawtext -n $win $colour(normal) "ms sans serif" 11 $calc($w - 125) 0 Time left
  drawtext -n $win $colour(normal) "ms sans serif" 11 $calc($w - 78) 0 Ack

  drawdot $win
  update_all
}
alias -l resize_window {
  if (%dcc.mouse.w) && (%dcc.mouse.h) && (%dcc.mouse.mx) && (%dcc.mouse.my) && ($mouse.key & 1) {
    var %.h = $calc($round($calc(($mouse.my - %dcc.mouse.my) / 13),0) * 13)
    var %w = $calc(%dcc.mouse.w + $mouse.mx - %dcc.mouse.mx),%h = $calc(%dcc.mouse.h + %.h)
    if ($calc($x + %w) > $window(-3).w) %w = $window(-3).w - $x
    if ($calc($y + %h) > $window(-3).h) %h = $window(-3).h - $y
    if (%w < 596) %w = 596
    if (%h < 62) %h = 62
    var %.w = $w,%.h = $h
    if (%w != %.w) || (%h != %.h) {
      if (%w != %.w) {
        if (%w > %.w) window $win $x $y %w %h
        drawcopy -n $win $calc(%.w - 451) 0 $w $h $win $calc(%w - 451) 0
        if (%w > %.w) drawrect -nf $win $colour(background) 1 $calc(%.w - 451) 0 $calc(%w - %.w) $h
        if (%w < %.w) window $win $x $y %w %h
        update_all_filenames
      }
      else window $win $x $y %w %h
      if (%h != %.h) {
        drawrect -nf $win $colour(background) 1 $calc(%w - 15) $calc(%.h - 40) 7 4
        drawrect -nf $win $colour(background) 1 $calc(%w - 15) $calc(%.h - 30) 7 7
        drawline -n $win $colour(normal) 1 $calc(%w - 12) $calc(%h - 37) $calc(%w - 9) $calc(%h - 40) $calc(%w - 15) $calc(%h - 40) $calc(%w - 12) $calc(%h - 37)
        drawline -n $win $colour(normal) 1 $calc(%w - 9) $calc(%h - 30) $calc(%w - 9) $calc(%h - 24) $calc(%w - 15) $calc(%h - 24) $calc(%w - 9) $calc(%h - 30)
        _ini lines $calc(($h - 36) / 13)
        update_current
        if (%h > %.h) update_all
      }
    }
    drawdot $win
  }
  else { .timerdcc_move off | unset %dcc.mouse.* }
}
alias update_all {
  drawrect -nf $win $colour(background) 1 0 14 $calc($w - 17) $h
  var %i = 1
  while ($line($current,%i)) {
    var %y = $calc(13 * %i),%n = $gettok($line($current,%i),3,59),%t = $gettok($line($current,%i),2,59)
    drawtext -nc $win $colour(normal) "ms sans serif" 11 1 %y 14 13 $base($calc($_ini(linepos) + %i - 1),10,10,2) $+ .
    drawtext -nc $win $colour(normal) "ms sans serif" 11 19 %y 25 13 %t
    var %a $ $+ %t
    drawtext -nc $win $colour(normal) "ms sans serif" 11 48 %y 51 13 [ %a $+ ( %n ) ]
    drawtext -nc $win $colour(normal) "ms sans serif" 11 103 %y $calc($w - 554) 13 [ %a $+ ( %n ).file ]
    var %size [ %a $+ ( %n ).size ]
    if (%t == get) var %rcvdsent [ %a $+ ( %n ).rcvd ]
    else var %rcvdsent [ %a $+ ( %n ).sent ]
    %rcvdsent = $base(%rcvdsent,10,10,$len(%size))
    if ( [ %a $+ ( %n ).pc ] != 100) drawtext -nc $win $colour(normal) "ms sans serif" 11 $calc($w - 447) %y 60 13 $comma(%rcvdsent)
    drawtext -nc $win $colour(normal) "ms sans serif" 11 $calc($w - 383) %y 60 13 $comma(%size)

    drawrect -n $win $colour(normal) 1 $calc($w - 318) $calc(%y + 1) 52 11
    if ( [ %a $+ ( %n ).status ] == inactive) var %color 15
    else var %color 2
    drawrect -nf $win %color 1 $calc($w - 317) $calc(%y + 2) $int($calc( [ %a $+ ( %n ).pc ] / 2)) 9
    drawtext -nc $win $colour(normal) "ms sans serif" 11 $calc($w - 262) %y 26 13 [ %a $+ ( %n ).pc ] $+ $chr(37)

    var %rate [ %a $+ ( %n ).cps ]
    if ( [ %a $+ ( %n ).status ] != inactive) drawtext -nc $win $colour(normal) "ms sans serif" 11 $calc($w - 232) %y 57 13 $size(%rate)
    if ( [ %a $+ ( %n ).status ] != inactive) drawtext -nc $win $colour(normal) "ms sans serif" 11 $calc($w - 171) %y 42 13 $formtime( [ %a $+ ( %n ).secs ] )
    if ( [ %a $+ ( %n ).status ] != inactive) drawtext -nc $win $colour(normal) "ms sans serif" 11 $calc($w - 125) %y 42 13 $formtime($calc((%size - %rcvdsent) / %rate))
    if (%t == send) && ( [ %a $+ ( %n ).status ] != inactive)  drawtext -nc $win $colour(normal) "ms sans serif" 11 $calc($w - 78) %y 60 13 $comma( [ %a $+ ( %n ).lra ] )
    inc %i
  }
  drawdot $win
}
alias -l update_all_filenames {
  var %i = 1
  while ($line($current,%i)) {
    var %y = $calc(13 * %i),%n = $gettok($line($current,%i),3,59),%t = $gettok($line($current,%i),2,59),%a = $ $+ %t
    drawtext -nc $win $colour(normal) "ms sans serif" 11 103 %y $calc($w - 554) 13 [ %a $+ ( %n ).file ]
    inc %i
  }
  drawdot $win
}
alias -l update_current {
  if ($calc($_ini(linepos) + $_ini(lines) - 1) > $line($data,0)) _ini linepos $calc($line($data,0) - $_ini(lines) + 1)
  if ($_ini(linepos) < 1) _ini linepos 1
  clear $current
  var %i = 1,%x = $_ini(linepos)
  while (%i <= $_ini(lines)) {
    if ($line($data,%x) == $null) break
    aline $current $line($data,%x)
    inc %x | inc %i
  }
}
alias -l update_data {
  clear $data
  unset %dcc.*
  var %i = 1
  while ($get(%i)) {
    ;window -h "Get from $get(%i) $+ "
    aline $data get;Get; $+ %i
    inc %i
  }
  var %i = 1
  while ($send(%i)) {
    ;window -h "Send to $send(%i) $+ "
    aline $data send;Send; $+ %i
    inc %i
  }
  update_current
  update_all 
}
alias -l update_transfers {
  if ($calc($get(0) + $send(0)) < 1) {
    window -c $data
    window -c $current
    .timertransferupdate off | .timertransferdetect 0 1 detect_transfers
    _ini x $x | _ini y $y | _ini w $w | _ini h $h
    window -c $win
    return
  }
  if ($calc($get(0) + $send(0)) != $line($data,0)) update_data
  if ($window($win).state != minimized) update_all
}

alias comma {
  var %comma $left($1,$calc($len($1) % 3)),%i = $calc($calc($len($1) % 3) + 1)
  while ($mid($1,%i,1) != $null) {
    %comma = %comma $+ $iif(%comma,$chr(44)) $+ $mid($1,%i,3)
    inc %i 3
  }
  return %comma
}
alias -l size {
  if ($1 < 1000) return $1 $+ b/s
  if ($1 < 1024000) return $round($calc($1 / 1024),2) $+ kb/s
  return $round($calc($1 / 1048576),2) $+ mb/s
}
alias -l formtime {
  var %a = $round($1,0)
  var %s = $calc(%a % 60)
  var %h = $int($calc(%a / 3600))
  var %m = $int($calc(((%a - (%h * 3600))) / 60))
  return $base(%h,10,10,2) $+ : $+ $base(%m,10,10,2) $+ : $+ $base(%s,10,10,2)
}

alias win return @DCCTransfers
alias -l data return @transfer_data
alias -l current return @transfer_current

alias x return $window($win).x
alias y return $window($win).y
alias -l w return $window($win).w
alias h return $window($win).h

menu @DCC {
  sclick: {
    if ($inrect($mouse.x,$mouse.y,$calc($w - 15),$calc($h - 30),10,10)) {
      %dcc.mouse.w = $w | %dcc.mouse.h = $h
      %dcc.mouse.mx = $mouse.mx | %dcc.mouse.my = $mouse.my
      .timerdcc_resize -m 0 1 resize_window
    }
    drawline -n $win $colour(normal) 1 $calc(%w - 12) 3 $calc(%w - 9) 6 $calc(%w - 15) 6 $calc(%w - 12) 3
    drawline -n $win $colour(normal) 1 $calc(%w - 12) $calc(%h - 37) $calc(%w - 9) $calc(%h - 40) $calc(%w - 15) $calc(%h - 40) $calc(%w - 12) $calc(%h - 37)
    if ($inrect($mouse.x,$mouse.y,$calc($w - 15),3,7,4)) {
      if ($_ini(linepos) == 1) return
      _ini linepos $calc($_ini(linepos) - 1)
      update_current
      update_all
    }
    if ($inrect($mouse.x,$mouse.y,$calc($w - 15),$calc($h - 40),7,4)) {
      if ($calc($_ini(linepos) + $_ini(lines) - 1) > $line($current,0)) return 
      _ini linepos $calc($_ini(linepos) + 1)
      update_current
      update_all
    }
  }
  uclick:.timerdcc_resize off | unset %dcc.mouse.*
}
