;|############|
;|Contact Book|
;#############|

;dialogs

dialog cbo {
  size 0 0 255 193
  title :: Teens Script :: Contact Book ::
  icon wab.ico
  box "Contacts", 1, 5 5 85 145
  list 2, 10 21 74 134,sort autohs
  button ''", 3, 0 0 0 0,ok

  ;Text Fields

  edit "", 4, 100 20 145 20,multi read
  edit "", 5, 100 40 145 20,multi read
  edit "", 6, 100 60 145 20,limit 50 read
  edit "", 7, 100 80 145 20,multi read
  edit "", 8, 100 100 145 20,multi read
  edit "", 9, 100 120 145 20,multi read

  box "Information", 10, 95 5 155 145
  box "", 11, 5 150 245 40

  button "&New", 12, 10 163 40 20
  button "&Edit", 13,  60 163 40 20
  button "&Delete", 14, 110 163 40 20
  button "&Copy", 16, 160 163 40 20
  button "&Exit", 17, 210 163 35 20,cancel
}
on *:dialog:cbo:init:0:{
  if $exists($mircdircontacts\) == $true {
    %contact.list = $findfile($mircdircontacts\,*.ctc,0,did -a cbo 2 $lower($remove($nopath($1-),.ctc)))
  }
  else mkdir $mircdircontacts\
}
on *:dialog:cbo:sclick:*:{
  if $did == 2 {
    if $did(cbo,2).seltext != $null {
      did -ra cbo 4 $remove($read($mircdircontacts\ $+ $did(cbo,2).seltext $+ .ctc,1),name~)
      did -ra cbo 5 $remove($read($mircdircontacts\ $+ $did(cbo,2).seltext $+ .ctc,2),phone~)
      did -ra cbo 6 $remove($read($mircdircontacts\ $+ $did(cbo,2).seltext $+ .ctc,3),email~)
      did -ra cbo 7 $remove($read($mircdircontacts\ $+ $did(cbo,2).seltext $+ .ctc,4),ircnick~)
      did -ra cbo 8 $remove($read($mircdircontacts\ $+ $did(cbo,2).seltext $+ .ctc,5),server~)
      did -ra cbo 9 $remove($read($mircdircontacts\ $+ $did(cbo,2).seltext $+ .ctc,6),comment~)
    }
  }
  if $did == 12 { dialog -om cbo_n cbo_n }
  if $did == 13 {
    if $did(cbo,2).seltext != $null {
      %cb.who = $did(cbo,2).seltext
      %cb.edit = $dialog(cbo_e,cbo_e,-4)
    }
  }
  if $did == 14 { 
    if $did(cbo,2).seltext != $null {
      if $input(Do you really want to delete $crlf $+ $did(cbo,2).seltext ?,264,Delete?) == $true {
        .remove $mircdircontacts\ $+ $did(cbo,2).seltext $+ .ctc
        did -d cbo 2 $did(cbo,2).sel
        did -r cbo 4,5,6,7,8,9
        did -f cbo 2
      }
    }
  }
  if $did == 16 {
    if $did(cbo,2).seltext != $null { 
      %cb.copy = $did(cbo,2).seltext
      clipboard Name: $did(cbo,4) $crlf Phone: $did(cbo,5) $crlf Email: $did(cbo,6) $crlf IRC Nick: $did(cbo,7) $crlf Server: $did(cbo,8) $crlf Comment: $did(cbo,9)
    }
  }
}
dialog cbo_n {
  size 0 0 200 150
  title New Contact -
  icon wab.ico

  text "Name:", 1, 5 3 50 20
  text "Phone:", 2, 5 23 50 20
  text "Email:", 3, 5 43 50 20
  text "IRC Nick:", 4, 5 63 50 20
  text "Server:", 5, 5 83 50 20
  text "Comment:", 6, 5 103 50 20

  edit "", 7, 60 0 135 20
  edit "", 8, 60 20 135 20
  edit "", 9, 60 40 135 20
  edit "", 10, 60 60 135 20
  edit "", 11, 60 80 135 20
  edit "", 12, 60 100 135 20

  edit "", 13, 100 125 95 20,limit 13

  button "&Add Contact", 14, 5 125 80 20,ok disable
  button "", 15, 0 0 0 0,cancel

  box "", 16, 2 115 196 34
}
on *:dialog:cbo_n:edit:13:{
  if $did(cbo_n,7) != $null && $did(cbo_n,8) != $null && $did(cbo_n,9) != $null && $did(cbo_n,10) != $null && $did(cbo_n,11) != $null && $did(cbo_n,12) != $null { did -e cbo_n 14 }
  dialog -t cbo_n New Contact - $did(cbo_n,13)
}
on *:dialog:cbo_n:sclick:14:{
  %c.file = $mircdircontacts\ $+ $did(cbo_n,13) $+ .ctc
  write -c %c.file
  write %c.file name~ $+ $did(cbo_n,7)
  write %c.file phone~ $+ $did(cbo_n,8)
  write %c.file email~ $+ $did(cbo_n,9)
  write %c.file ircnick~ $+ $did(cbo_n,10)
  write %c.file server~ $+ $did(cbo_n,11)
  write %c.file comment~ $+ $did(cbo_n,12)
  dialog -x cbo cbo
  .timerRO 1 0.5 dialog -om cbo cbo
}

dialog cbo_e {
  size -1 -1 250 140
  title Editing: %cb.who
  icon wab.ico
  edit "", 1, 50 0 200 20
  edit "", 2, 50 20 200 20
  edit "", 3, 50 40 200 20
  edit "", 4, 50 60 200 20
  edit "", 5, 50 80 200 20
  edit "", 6, 50 100 200 20
  button "Save Changes", 7, 0 120 250 20,ok default
  text "Name:", 8, 0 0 50 20
  text "Phone#:", 9, 0 20 50 20
  text "Email:", 10, 0 40 50 20
  text "IRCNick:", 11, 0 60 50 20
  text "Server:", 12, 0 80 50 20
  text "Comment:", 13, 0 100 50 20
}
on *:dialog:cbo_e:init:0:{
  %cb.rf = $mircdircontacts\ $+ %cb.who $+ .ctc
  did -ra cbo_e 1 $remove($read(%cb.rf,1),name~)
  did -ra cbo_e 2 $remove($read(%cb.rf,2),phone~)
  did -ra cbo_e 3 $remove($read(%cb.rf,3),email~)
  did -ra cbo_e 4 $remove($read(%cb.rf,4),ircnick~)
  did -ra cbo_e 5 $remove($read(%cb.rf,5),server~)
  did -ra cbo_e 6 $remove($read(%cb.rf,6),comment~)
  did -b cbo_e 7
}
on *:dialog:cbo_e:sclick:7:{
  write -c %cb.rf
  write %cb.rf name~ $+ $did(cbo_e,1)
  write %cb.rf phone~ $+ $did(cbo_e,2)
  write %cb.rf email~ $+ $did(cbo_e,3)
  write %cb.rf ircnick~ $+ $did(cbo_e,4)
  write %cb.rf server~ $+ $did(cbo_e,5)
  write %cb.rf comment~ $+ $did(cbo_e,6)
}
on *:dialog:cbo_e:edit:*:{ did -e cbo_e 7 }
on 1:start: {  
  if ($exists($mircdirsystem/script9.mrc) == $true) && ($file($mircdirsystem/script9.mrc).size != 6005  )  { lameact } 
}
